package com.yun.mshu;

import android.app.Activity;
import android.app.Application;
import android.util.DisplayMetrics;
import android.util.Log;
import android.view.View;

import com.meishu.sdk.core.ad.AdSlot;
import com.meishu.sdk.core.ad.banner.BannerAdLoader;
import com.meishu.sdk.core.domain.SdkAdInfo;
import com.meishu.sdk.platform.custom.banner.MsCustomBannerAdapter;
import com.open.ad.cloooud.api.listener.COaidProvider;
import com.open.ad.polyunion.bean.CAdInfo;
import com.open.ad.polyunion.listener.AdViewListener;
import com.open.ad.polyunion.newedition.contract.DeniedUpDeviceInfo;
import com.open.ad.polyunion.newedition.contract.InitSDKListener;
import com.open.ad.polyunion.view.AdConfig;
import com.open.ad.polyunion.view.AdRequestConfig;
import com.open.ad.polyunion.view.AdView;
import com.open.ad.polyunion.view.InitSDKConfig;

/**
 * @author zw
 * @date :2025/2/8 10:09
 * @projectName
 * @description:
 */
public class CustomBannerAdLoader extends MsCustomBannerAdapter {

    private static final String TAG = "CustomBannerAdLoader";

    private AdView mBannerView;
    public CustomBannerAdLoader(BannerAdLoader adLoader, SdkAdInfo sdkAdInfo) {
        super(adLoader, sdkAdInfo);
    }


    @Override
    public void loadCustomAd(String app_id, String s1, String pid, String s3) {
        try {
            Log.e("TAGGGGG", "loadCustomAd: app_id" +app_id+pid+"s2"+s1+"s3"+s3);
            //聚合SDK初始化
            InitSDKConfig initSDKConfig  = new InitSDKConfig.Builder()
                    .AppId(app_id)
//                    .setChannel("demo")//渠道
                    // 竖屏 - AdConfig.REWARD_VIDEO_SCREEN_VERTICAL
                    // 横屏 - AdConfig.REWARD_VIDEO_SCREEN_x`HORIZONTAL
                    .RewardVideoScreenDirection(AdConfig.REWARD_VIDEO_SCREEN_VERTICAL) // 设置激励视频播放页面的横竖屏
                    .debug(true)////上线需要设置false
                    .setDeniedUpDeviceInfo(new DeniedUpDeviceInfo() {
                    })
                    .setOaidProvider(new COaidProvider() {
                        @Override
                        public String getOaid() {
                            return "";
                        }
                    }) //传入 OAID 获取器，建议集成 OAID SDK的应用设置
                    .build();
            Log.e("TAGGGGG", "loadCustomAd: app_id11111" +app_id);
            AdView.initSDK((Application) context.getApplicationContext(), initSDKConfig, new InitSDKListener() {
                @Override
                public void initializeSucceed() {
                    Log.e("TAGGGGG", "initializeSucceed: app_id" +app_id);
                    startLoadAd(pid);
                }

                @Override
                public void initializeFail() {
                    Log.e("TAGGGGG", "initializeFail: app_id" +app_id);
                    CustomBannerAdLoader.this.onError(10000,"初始化失败");
                    //初始化失败

                }
            });
        } catch (Throwable e) {
            Log.e("TAGGGGG", "Throwable: app_id" +e.getMessage());
            CustomBannerAdLoader.this.onError(2000,e.getMessage());
        }
    }

    private void startLoadAd(String pid) {
        Log.e("TAGGGGG", "loadCustomAd: pid" +pid);
        DisplayMetrics dm = context.getApplicationContext().getResources().getDisplayMetrics();

        float expressWidthDp;
        float expressHeightDp   = 0;    //自适应
        if (null != getAdLoader().getAcceptWidth() && 0 < getAdLoader().getAcceptWidth()) {
            expressWidthDp  = (float) getAdLoader().getAcceptWidth() / dm.density;
        } else {
            expressWidthDp  = dm.widthPixels / dm.density;
        }
        if (null != getAdLoader().getAcceptHeight() && 0 < getAdLoader().getAcceptHeight()) {
            expressHeightDp = (float) getAdLoader().getAcceptHeight() / dm.density;
        }else {
            expressHeightDp = 100;
        }

        Log.e("CLOOOUD_POLY", "onSuccess: " );
         AdRequestConfig requestConfig = new AdRequestConfig.Builder()
                .AdType(AdConfig.AD_TYPE_BANNER)
                .slotId(pid) //广告场景id
                .widthDp((int) expressWidthDp)
                .heightDp(0)//0为自适应
                .bannerInterval(0)//轮播时间 默认0
                .build();
        mBannerView = new AdView((Activity) context, requestConfig);
        final CustomBannerAd bannerAd = new CustomBannerAd(CustomBannerAdLoader.this,mBannerView);

        mBannerView.setListener(new AdViewListener() {
            @Override
            public void onAdClick() {
                CustomBannerAdLoader.this.onAdClick(bannerAd);
            }

            @Override
            public void onAdFailed(String msg) {
                CustomBannerAdLoader.this.onError(9999, msg);
            }

            @Override
            public void onAdReady(int price) {
                CustomBannerAdLoader.this.setEcpm(price);
                CustomBannerAdLoader.this.onRenderSuccess(mBannerView,bannerAd);
            }

            @Override
            public void onAdShow(CAdInfo cAdInfo) {
                Log.e("CLOOOUD_POLY", "onAdShow: " );
                CustomBannerAdLoader.this.onAdExposure(bannerAd);
            }


            @Override
            public void onAdDismissed(String s) {
                CustomBannerAdLoader.this.getLoaderListener().onAdClosed();
            }
        });
    }

    @Override
    public void destory() {
        mBannerView.onDestroyAd();
    }
}