package com.yun.mshu;

import android.app.Activity;
import android.content.Context;
import android.util.Log;
import android.view.View;
import android.view.ViewGroup;

import com.meishu.sdk.core.ad.recycler.ExpressMediaListener;
import com.meishu.sdk.core.utils.MsAdPatternType;
import com.meishu.sdk.core.utils.MsInteractionType;
import com.meishu.sdk.platform.custom.recycler.MsCustomRecyclerAdapter;
import com.meishu.sdk.platform.custom.recycler.MsCustomRecyclerExpressAd;
import com.open.ad.polyunion.bean.CAdInfo;
import com.open.ad.polyunion.view.AdConfig;
import com.open.ad.polyunion.view.NativeAdsResponse;

import java.util.ArrayList;
import java.util.List;

/**
 * @author zw
 * @date :2025/2/8 15:00
 * @projectName
 * @description:
 */
public class CustomExpressAd extends MsCustomRecyclerExpressAd {
    private MsCustomRecyclerAdapter adWrapper;
    private NativeAdsResponse response;

    public CustomExpressAd(MsCustomRecyclerAdapter adWrapper, NativeAdsResponse response) {
        super(adWrapper);
        this.adWrapper = adWrapper;
        this.response = response;
    }

    @Override
    public int getAdPatternType() {
        int imageMode = response.getSelfRenderAdMediaType();
        int adPatternType = MsAdPatternType.LARGE_IMAGE;
        switch (imageMode) {
            case NativeAdsResponse.NATIVE_AD_MEDIA_TYPE_VIDEO:
                adPatternType = MsAdPatternType.VIDEO;
                break;
            default:
                adPatternType = MsAdPatternType.IMAGE;
                break;
        }
        return adPatternType;
    }

    @Override
    public int getInteractionType() {
        int interactionType = MsInteractionType.NORMAL;
        switch (response.getInteractionType()){
            case AdConfig.NATIVE_INTERACTION_TYPE_DOWNLOAD:
                interactionType = MsInteractionType.DOWNLOAD_APP;
                break;
            default:
                interactionType = MsInteractionType.NORMAL;
                break;
        }
        return interactionType;
    }



    @Override
    protected void bindAdToView(Context context, ViewGroup container, List<View> clickableViews) {
        Activity dialogContext=null;
        if (context instanceof Activity){
            dialogContext= (Activity) context;
        }else if (container.getContext() instanceof Activity){
            dialogContext = (Activity) container.getContext();
        }

        if (container != null && getAdView() != null) {
            container.removeAllViews();
            container.addView(getAdView());
        }


        try {
            // 注册原生信息流广告可点击区域视图，建议为客户端单个原生广告位所有区域，在广告展现时调用
            response.registerNativeClickableView(
                    (ViewGroup) container,
                    context,
                    (ViewGroup) container,
                    null);
        } catch (Throwable e) {
            e.printStackTrace();
        }
    }

    @Override
    public void setExpressMediaListener(final ExpressMediaListener mediaListener) {

    }

    @Override
    public View getAdView() {
        return response.getExpressAdView();
    }

    @Override
    public void destroy() {
        if (response!=null){
            response.onDestroy();
            response=null;
        }
    }

    @Override
    public boolean isNativeExpress() {
        return true;
    }
}