package com.yun.mshu;

import android.app.Activity;
import android.app.Application;
import android.util.DisplayMetrics;
import android.util.Log;

import com.meishu.sdk.core.ad.AdSlot;
import com.meishu.sdk.core.ad.interstitial.InterstitialAdLoader;
import com.meishu.sdk.core.domain.SdkAdInfo;
import com.meishu.sdk.platform.custom.interstitial.MsCustomInterstitialAdapter;
import com.open.ad.cloooud.api.listener.COaidProvider;
import com.open.ad.polyunion.bean.CAdInfo;
import com.open.ad.polyunion.listener.AdViewListener;
import com.open.ad.polyunion.newedition.contract.DeniedUpDeviceInfo;
import com.open.ad.polyunion.newedition.contract.InitSDKListener;
import com.open.ad.polyunion.view.AdConfig;
import com.open.ad.polyunion.view.AdRequestConfig;
import com.open.ad.polyunion.view.AdView;
import com.open.ad.polyunion.view.InitSDKConfig;

/**
 * @author zw
 * @date :2025/2/8 11:15
 * @projectName
 * @description:
 */
public class CustomInterstitialAdLoader extends MsCustomInterstitialAdapter {
    private static final String TAG = "CustomInterstitialAdLoa";
    private AdView interstialAd;
    public CustomInterstitialAdLoader(InterstitialAdLoader adLoader, SdkAdInfo sdkAdInfo) {
        super(adLoader, sdkAdInfo);
    }

    @Override
    public void loadCustomAd(String app_id, String s1, String pid, String s3) {
        try {
            //聚合SDK初始化
            InitSDKConfig initSDKConfig  = new InitSDKConfig.Builder()
                    .AppId(app_id)
//                    .setChannel("demo")//渠道
                    // 竖屏 - AdConfig.REWARD_VIDEO_SCREEN_VERTICAL
                    // 横屏 - AdConfig.REWARD_VIDEO_SCREEN_x`HORIZONTAL
                    .RewardVideoScreenDirection(AdConfig.REWARD_VIDEO_SCREEN_VERTICAL) // 设置激励视频播放页面的横竖屏
                    .debug(true)////上线需要设置false
                    .setDeniedUpDeviceInfo(new DeniedUpDeviceInfo() {
                    })
                    .setOaidProvider(new COaidProvider() {
                        @Override
                        public String getOaid() {
                            return "";
                        }
                    }) //传入 OAID 获取器，建议集成 OAID SDK的应用设置
                    .build();
            AdView.initSDK((Application) context.getApplicationContext(), initSDKConfig, new InitSDKListener() {
                @Override
                public void initializeSucceed() {
                    startLoadAd(pid);
                }

                @Override
                public void initializeFail() {
                    CustomInterstitialAdLoader.this.onError(10000,"初始化失败");
                    //初始化失败

                }
            });
        } catch (Throwable e) {
            CustomInterstitialAdLoader.this.onError(2000,e.getMessage());
        }
    }

    private void startLoadAd(String pid) {
        int adContentWidth = 1080;
        int adContentHeight = 1920;
        try {
            DisplayMetrics displayMetrics = this.adLoader.getContext().getResources().getDisplayMetrics();
            if (0 < displayMetrics.widthPixels && 0 < displayMetrics.heightPixels) {
                adContentWidth  = displayMetrics.widthPixels;
                adContentHeight = displayMetrics.heightPixels;
            }
        } catch (Exception e) {}
        AdRequestConfig requestConfig = new AdRequestConfig.Builder()
                .AdType(AdConfig.AD_TYPE_INTERSTITIAL)
                .slotId(pid) //广告场景id
                .widthDp(adContentWidth)
                .heightDp(adContentHeight)
                .build();
        interstialAd = new AdView((Activity) context, requestConfig);
        final CustomInterstitialAd screenVideoAd = new CustomInterstitialAd(CustomInterstitialAdLoader.this,interstialAd);

        interstialAd.setListener(new AdViewListener() {
            @Override
            public void onAdClick() {
                CustomInterstitialAdLoader.this.onAdClick(screenVideoAd);
            }

            @Override
            public void onAdFailed(String msg) {
                CustomInterstitialAdLoader.this.onError(9999,msg);
            }

            @Override
            public void onAdReady(int price) {
                Log.e("TAGGGG", "onAdReady: "+ price);
                CustomInterstitialAdLoader.this.setEcpm(price);
                CustomInterstitialAdLoader.this.onRenderSuccess(screenVideoAd);
            }

            @Override
            public void onAdShow(CAdInfo cAdInfo) {
                CustomInterstitialAdLoader.this.onAdExposure(screenVideoAd);
            }

            @Override
            public void onAdDismissed(String s) {
                CustomInterstitialAdLoader.this.onAdClosed(screenVideoAd);
            }
        });
    }
}