package com.yun.mshu;

import android.app.Activity;
import android.app.Application;
import android.content.Context;
import android.os.Bundle;
import android.util.DisplayMetrics;
import android.util.Log;
import android.view.Surface;
import android.view.WindowManager;

import com.meishu.sdk.core.AdSdk;
import com.meishu.sdk.core.ad.AdSlot;
import com.meishu.sdk.core.ad.reward.RewardVideoLoader;
import com.meishu.sdk.core.domain.SdkAdInfo;
import com.meishu.sdk.platform.custom.reward.MsCustomRewardAdapter;
import com.open.ad.cloooud.api.listener.COaidProvider;
import com.open.ad.polyunion.bean.CAdInfo;
import com.open.ad.polyunion.listener.RewardVideoListener;
import com.open.ad.polyunion.newedition.contract.DeniedUpDeviceInfo;
import com.open.ad.polyunion.newedition.contract.InitSDKListener;
import com.open.ad.polyunion.view.AdConfig;
import com.open.ad.polyunion.view.AdRequestConfig;
import com.open.ad.polyunion.view.AdView;
import com.open.ad.polyunion.view.InitSDKConfig;

/**
 * @author zw
 * @date :2025/2/8 11:46
 * @projectName
 * @description:
 */
public class CustomRewardAdLoader extends MsCustomRewardAdapter {
    private AdView rewardVideo;

    public CustomRewardAdLoader(RewardVideoLoader adLoader, SdkAdInfo sdkAdInfo) {
        super(adLoader, sdkAdInfo);
    }

    @Override
    public void loadCustomAd(String app_id, String s1, String pid, String s3) {
        try {
            Log.e("TAGGGGG", "loadCustomAd: app_id" +app_id+pid+"s2"+s1+"s3"+s3);

            //聚合SDK初始化
            InitSDKConfig initSDKConfig  = new InitSDKConfig.Builder()
                    .AppId(app_id)
//                    .setChannel("demo")//渠道
                    // 竖屏 - AdConfig.REWARD_VIDEO_SCREEN_VERTICAL
                    // 横屏 - AdConfig.REWARD_VIDEO_SCREEN_x`HORIZONTAL
                    .RewardVideoScreenDirection(AdConfig.REWARD_VIDEO_SCREEN_VERTICAL) // 设置激励视频播放页面的横竖屏
                    .debug(true)////上线需要设置false
                    .setDeniedUpDeviceInfo(new DeniedUpDeviceInfo() {
                    })
                    .setOaidProvider(new COaidProvider() {
                        @Override
                        public String getOaid() {
                            return "";
                        }
                    }) //传入 OAID 获取器，建议集成 OAID SDK的应用设置
                    .build();
            AdView.initSDK((Application) context.getApplicationContext(), initSDKConfig, new InitSDKListener() {
                @Override
                public void initializeSucceed() {
                    Log.e("TAGGGGG", "loadCustomAd: 222" );
                    startLoadAd(pid);
                }

                @Override
                public void initializeFail() {
                    CustomRewardAdLoader.this.onError(10000,"初始化失败");
                    //初始化失败
                    Log.e("TAGGGGG", "loadCustomAd: 333" );

                }
            });
        } catch (Throwable e) {
            Log.e("TAGGGGG", "loadCustomAd: 444");

            CustomRewardAdLoader.this.onError(2000,e.getMessage());
        }
    }


    private void startLoadAd(String pid) {
        AdRequestConfig requestConfig = new AdRequestConfig.Builder()
                .AdType(AdConfig.AD_TYPE_REWARDVIDEO)
                .requestTimeOutMillis(10000) //设置聚合SDK请求前超时时间，毫秒
                .slotId(pid) //广告场景id
                .build();
        rewardVideo = new AdView((Activity) context, requestConfig);
        CustomRewardAd customRewardAd = new CustomRewardAd(CustomRewardAdLoader.this,rewardVideo);

        rewardVideo.setRewardVideoListener(new RewardVideoListener() {

            @Override
            public void onAdFailed(String msg) {
                CustomRewardAdLoader.this.onError(9999,msg);
            }

            @Override
            public void onVideoComplete() {
                CustomRewardAdLoader.this.onSkippedVideo(customRewardAd);
                CustomRewardAdLoader.this.onVideoCompleted(customRewardAd);
            }

            @Override
            public void onAdReward() {
                CustomRewardAdLoader.this.onReward(customRewardAd,null);
            }

            @Override
            public void onAdClose() {
                CustomRewardAdLoader.this.onAdClosed(customRewardAd);
            }

            @Override
            public void onAdReady(int price) {
                CustomRewardAdLoader.this.setEcpm(price);
                CustomRewardAdLoader.this.onRenderSuccess(customRewardAd);
            }

            @Override
            public void onVideoCached() {
                CustomRewardAdLoader.this.onVideoCached(customRewardAd);
            }

            @Override
            public void onAdShow(CAdInfo cAdInfo) {
                CustomRewardAdLoader.this.onAdExposure(customRewardAd);
                CustomRewardAdLoader.this.onVideoStart(customRewardAd);
            }

            @Override
            public void onAdClick(String s) {
                CustomRewardAdLoader.this.onAdClick(customRewardAd);
            }
        });

    }
}
